if not StellarUF then return end

StellarTick = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")
local penergy = -1
local pmana = 99999
local ptime = 0
local p, go, f, spark, rat, ou
local dead, combat = UnitIsDeadOrGhost, InCombatLockdown


local elap = 0
local function Update()
	elap = elap + arg1
	if elap < 0.03 then return end
	
	if dead("player") or p == 1 then 
		spark:Hide() 
	elseif p == 3 then
		ptime = ptime + elap
		if ptime > 1.99 then
			ptime = 0
		end
		local perc = ptime / 1.99
		spark:SetPoint("CENTER", f, "LEFT", perc * f:GetWidth(), 0)
		spark:SetAlpha(perc)
		spark:Show()
	elseif go and p == 0 then
		ptime = ptime + elap
		if ptime > 5 then
			spark:Hide()
			go = nil
		else
			local perc = ptime / 5
			spark:SetPoint("CENTER", f, "LEFT", perc * f:GetWidth(), 0)
			spark:SetAlpha(perc)
		end
	end
	elap = 0
end
-- some cheap logic to detect if an energy increase was a regen tick
local function IsRegenTick()
	-- only regen that ticks for exactly 20 in combat
	local m = UnitMana("player")
	if combat() and m ~= UnitManaMax("player") and m == (penergy + 20) then 
		return true 
	end
	-- any regen outside of combat 
	if not combat() and m > penergy then 
		return true 
	end
	
	return false
end

local function BuildTick()
	f = StellarUF.units.player.mp
	ou = CreateFrame("FRAME", nil, f)
	ou:SetScript("OnUpdate", Update)

	spark = f:CreateTexture(nil, "OVERLAY")
	spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	spark:SetWidth(8)
	spark:SetHeight(f:GetHeight()*2.5)
	spark:SetBlendMode("ADD")
	spark:SetAlpha(0.6)
	return true
end


function StellarTick:OnInitialize()
	local _,cls = UnitClass("player")
	if cls == "WARRIOR" then return end
	if BuildTick() then
		if cls == "ROGUE" then 
			self:RegisterEvent("UNIT_ENERGY")
			p = 3
		elseif cls == "DRUID" then
			self:RegisterEvent("UNIT_MANA")
			self:RegisterEvent("UNIT_ENERGY")
			self:RegisterEvent("UNIT_DISPLAYPOWER", function()
				if arg1 ~= "player" then return end
				p = UnitPowerType("player")
				spark:Hide()
				go = nil
			end)
			p = UnitPowerType("player")
		else
			self:RegisterEvent("UNIT_MANA")
			p = 0
		end
	end
end

function StellarTick:UNIT_MANA()
	if arg1 ~= "player" then return end
	if UnitMana("player") < pmana then 
		ptime = 0 
		go = true
		spark:Show()
	end
	pmana = UnitMana("player")
end

function StellarTick:UNIT_ENERGY()
	if arg1 ~= "player" then return end
	if IsRegenTick() then 
		ptime = 0 
	end
	penergy = UnitMana("player")
end

